#include <windows.h>
#include <WindowsX.h>
#include "resource.h"

#define CLASSNAME   "WinApp_TestAPClass"
#define APPNAME     "winapp"

LRESULT OnDestroy(HWND hWnd)	//wb_[̎ɒǉ
{
    PostQuitMessage(0);
    return 0;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	WORD wId = LOWORD(wParam);

	PAINTSTRUCT ps; 
    HDC         hDC;
    CHAR        szBuff[256];
    int         iSize;

    switch(uMsg){
        // 
        case WM_COMMAND:
            switch(wId){
                case ID_QUIT:
                    DestroyWindow(hWnd);
                    break;
                case ID_ABOUT:
                    MessageBox(hWnd, "WinApp.exeTv",
                            APPNAME, MB_OK|MB_ICONINFORMATION);
                    break;
                default:
                    break;
            }
            break;
			case WM_PAINT:
            hDC = BeginPaint(hWnd, &ps);
            iSize = wsprintf(szBuff, "WM_PAINTs");
            TextOut(hDC, 10, 10, szBuff, iSize);
            EndPaint(hWnd, &ps);
            break;
        case WM_CHAR:
            hDC = GetDC(hWnd);
            iSize = wsprintf(szBuff, "%c L[܂ ", wParam);
            TextOut(hDC, 10, 30, szBuff, iSize);
            ReleaseDC(hWnd, hDC);
            break;
        // ܂łǉ܂B
        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
        default:
            break;
	}
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int APIENTRY WinMain(

HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
HWND        hWnd = NULL;
WNDCLASSEX  wc;
MSG         msg;
wc.cbSize        = sizeof(WNDCLASSEX);

    wc.style         = 0;
    wc.lpfnWndProc   = (WNDPROC)WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon   = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_WINAPP),
                       IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
    wc.hCursor       = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
                            IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MAINMENU);//̍sC
    wc.lpszClassName = CLASSNAME;
    wc.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_WINAPP),
                       IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
    if(RegisterClassEx(&wc) == 0){
        return GetLastError();
	}

	hWnd = CreateWindowEx(0, CLASSNAME, APPNAME, WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, SW_MINIMIZE, CW_USEDEFAULT, CW_USEDEFAULT,
        NULL, NULL, hInstance, NULL);
    if(hWnd == NULL){
        return GetLastError();
    }

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

	while(GetMessage(&msg, NULL, 0, 0)){
    TranslateMessage(&msg);
    DispatchMessage(&msg);
}
return msg.wParam;
}
